org.apache.xalan.xsltc.runtime

## Class AttributeList

- java.lang.Object
- - org.apache.xalan.xsltc.runtime.AttributeList

All Implemented Interfaces:
  Attributes

    public class AttributeList
    extends java.lang.Object
    implements Attributes

Author:
  Morten Jorgensen

### Constructor Summary

Constructors
Constructor and Description
`AttributeList()` AttributeList constructor
`AttributeList(Attributes attributes)` Attributes clone constructor

### Method Summary

Methods
`void` `add(java.lang.String qname, java.lang.String value)` Adds an attribute to the list
`void` `clear()` Clears the attribute list
`int` `getIndex(java.lang.String qname)` SAX2: Look up the index of an attribute by XML 1.0 qualified name.
`int` `getIndex(java.lang.String namespaceURI, java.lang.String localPart)` SAX2: Look up the index of an attribute by Namespace name.
`int` `getLength()` SAX2: Return the number of attributes in the list.
`java.lang.String` `getLocalName(int index)` SAX2: Look up an attribute's local name by index.
`java.lang.String` `getQName(int pos)` Return the name of an attribute in this list (by position).
`java.lang.String` `getType(int index)` SAX2: Look up an attribute's type by index.
`java.lang.String` `getType(java.lang.String qname)` SAX2: Look up an attribute's type by qname.
`java.lang.String` `getType(java.lang.String uri, java.lang.String localName)` SAX2: Look up an attribute's type by Namespace name.
`java.lang.String` `getURI(int index)` SAX2: Look up an attribute's Namespace URI by index.
`java.lang.String` `getValue(int pos)` SAX2: Look up an attribute's value by index.
`java.lang.String` `getValue(java.lang.String qname)` SAX2: Look up an attribute's value by qname.
`java.lang.String` `getValue(java.lang.String uri, java.lang.String localName)` SAX2: Look up an attribute's value by Namespace name - SLOW!

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AttributeList

    public AttributeList()

AttributeList constructor

#### AttributeList

    public AttributeList(Attributes attributes)

Attributes clone constructor

### Method Detail

#### getLength

    public int getLength()

SAX2: Return the number of attributes in the list.

Specified by:
  `getLength` in interface `Attributes`
Returns:
  The number of attributes in the list.
See Also:
  `Attributes.getURI(int)`, `Attributes.getLocalName(int)`, `Attributes.getQName(int)`, `Attributes.getType(int)`, `Attributes.getValue(int)`

#### getURI

    public java.lang.String getURI(int index)

SAX2: Look up an attribute's Namespace URI by index.

Specified by:
  `getURI` in interface `Attributes`
Parameters:
  `index` - The attribute index (zero-based).
Returns:
  The Namespace URI, or the empty string if none is available, or null if the index is out of range.
See Also:
  `Attributes.getLength()`

#### getLocalName

    public java.lang.String getLocalName(int index)

SAX2: Look up an attribute's local name by index.

Specified by:
  `getLocalName` in interface `Attributes`
Parameters:
  `index` - The attribute index (zero-based).
Returns:
  The local name, or the empty string if Namespace processing is not being performed, or null if the index is out of range.
See Also:
  `Attributes.getLength()`

#### getQName

    public java.lang.String getQName(int pos)

Return the name of an attribute in this list (by position).

Specified by:
  `getQName` in interface `Attributes`
Parameters:
  `pos` - The attribute index (zero-based).
Returns:
  The XML qualified name, or the empty string if none is available, or null if the index is out of range.
See Also:
  `Attributes.getLength()`

#### getType

    public java.lang.String getType(int index)

SAX2: Look up an attribute's type by index.

Specified by:
  `getType` in interface `Attributes`
Parameters:
  `index` - The attribute index (zero-based).
Returns:
  The attribute's type as a string, or null if the index is out of range.
See Also:
  `Attributes.getLength()`

#### getIndex

    public int getIndex(java.lang.String namespaceURI,
               java.lang.String localPart)

SAX2: Look up the index of an attribute by Namespace name.

Specified by:
  `getIndex` in interface `Attributes`
Parameters:
  `namespaceURI` - The Namespace URI, or the empty string if the name has no Namespace URI.
  `localPart` - The attribute's local name.
Returns:
  The index of the attribute, or -1 if it does not appear in the list.

#### getIndex

    public int getIndex(java.lang.String qname)

SAX2: Look up the index of an attribute by XML 1.0 qualified name.

Specified by:
  `getIndex` in interface `Attributes`
Parameters:
  `qname` - The qualified (prefixed) name.
Returns:
  The index of the attribute, or -1 if it does not appear in the list.

#### getType

    public java.lang.String getType(java.lang.String uri,
                           java.lang.String localName)

SAX2: Look up an attribute's type by Namespace name.

Specified by:
  `getType` in interface `Attributes`
Parameters:
  `uri` - The Namespace URI, or the empty String if the name has no Namespace URI.
  `localName` - The local name of the attribute.
Returns:
  The attribute type as a string, or null if the attribute is not in the list or if Namespace processing is not being performed.

#### getType

    public java.lang.String getType(java.lang.String qname)

SAX2: Look up an attribute's type by qname.

Specified by:
  `getType` in interface `Attributes`
Parameters:
  `qname` - The XML qualified name.
Returns:
  The attribute type as a string, or null if the attribute is not in the list or if qualified names are not available.

#### getValue

    public java.lang.String getValue(int pos)

SAX2: Look up an attribute's value by index.

Specified by:
  `getValue` in interface `Attributes`
Parameters:
  `pos` - The attribute index (zero-based).
Returns:
  The attribute's value as a string, or null if the index is out of range.
See Also:
  `Attributes.getLength()`

#### getValue

    public java.lang.String getValue(java.lang.String qname)

SAX2: Look up an attribute's value by qname.

Specified by:
  `getValue` in interface `Attributes`
Parameters:
  `qname` - The XML qualified name.
Returns:
  The attribute value as a string, or null if the attribute is not in the list or if qualified names are not available.

#### getValue

    public java.lang.String getValue(java.lang.String uri,
                            java.lang.String localName)

SAX2: Look up an attribute's value by Namespace name - SLOW!

Specified by:
  `getValue` in interface `Attributes`
Parameters:
  `uri` - The Namespace URI, or the empty String if the name has no Namespace URI.
  `localName` - The local name of the attribute.
Returns:
  The attribute value as a string, or null if the attribute is not in the list.

#### add

    public void add(java.lang.String qname,
           java.lang.String value)

Adds an attribute to the list

#### clear

    public void clear()

Clears the attribute list